# Octavia
🎻 Event-driven multi-standard MIDI state-tracking library. Working with MIDI should be simple, while faithful and professional.

Made with ❤️ by Lightingale Community. Repository available on [Codeberg](https://codeberg.org/ltgc/octavia/), [GitHub](https://github.com/ltgcgo/octavia/) and [GitLab](https://gitlab.com/ltgc/oss/octavia/).

[![Maintainability](https://api.codeclimate.com/v1/badges/fa5aeaf4ba4c9b2d50e2/maintainability)](https://codeclimate.com/github/ltgcgo/octavia/maintainability)

## Why Octavia over others?
* Free, libre and open-source, under GNU LGPL v3.0.
* Behaves like a real MIDI module, doing most of the heavy-lifting for you.
* Developed with Firefox and an open Web in mind.
* Supports 8 ports, 128 channels, 512-voice polyphony maximum. More than you'll ever need.
* Built-in support of several standards, multiple plug-in cards, and tons of devices.
* Tells when MIDI programming errors are spotted, reducing chances of faulty programming.
* Available in JS (browser and Deno).
* No modification required to run in Tor Browser, Bromite and LibreWolf.
* Wide support of bank mapping and bitmaps via [`midi-db`](https://github.com/ltgcgo/midi-db).
<!--* [Less than 20 kilobytes when compressed](docs/support/compress.md).-->

## Support
Octavia offers support to a wide range of targets, most of them being either GM-compliant or having strong historical importance. Read the [support page](docs/support/target.md) for more information.

To have a general idea of how MIDI is implemented, refer to the [MIDI Implementation Chart](docs/support/implementation.md) and [Supported SysEx instructions](docs/support/sysex.md).

## Dev talks
We're now hosting a new place to handle development talks! If you don't have a GitHub account, or just prefer to report bugs or give suggestions in a more casual way, feel free to chat with us with links below!

* Fediverse (Mastodon): [@lightingale@fosstodon.org](https://fosstodon.org/@lightingale)
* Telegram channel: [@ltgc_t](https://t.me/s/ltgc_t)
* Telegram group chat: [Click to join](https://t.me/+0I30mcOPTSQ0ZGIx)

## Credits
Please read [CREDITS.md](CREDITS.md).

## API & more
Please read the [documentation](docs/README.md).

## Examples
Please check out the `/examples/` directory.

## Contribute
You can help with Octavia's development, by doing any of the following, or more...
* Test Octavia, whether under production environment or not.
* Write anything utilizing Octavia's API.
* Report any bugs you find.
* Submit feature requests.
* Participate in programming (read the docs for further info).
* Reward the developers some donation.
* Spread the word about Octavia.